Orxonox: orxonox::ParticleEmitter Class Reference

# orxonox::ParticleEmitter Class Reference

`#include <src/orxonox/objects/worldentities/ParticleEmitter.h>`

Inheritance diagram for orxonox::ParticleEmitter:

List of all members.

## Public Member Functions

virtual void | changedActivity ()
| This function gets called if the activity of the object changes.
virtual void | changedVisibility ()
| This function gets called if the visibility of the object changes.
LODParticle::Value | getLOD () const
ParticleInterface * | getParticleInterface () const
const std::string & | getSource () const
| ParticleEmitter (BaseObject *creator)
void | registerVariables ()
void | setLOD (LODParticle::Value level)
void | setSource (const std::string &source)
virtual void | XMLPort (Element &xmlelement, XMLPort::Mode mode)
| XML loading and saving.
| ~ParticleEmitter ()

## Protected Member Functions

unsigned int | getLODxml () const
void | LODchanged ()
void | setLODxml (unsigned int level)
void | sourceChanged ()

## Protected Attributes

LODParticle::Value | LOD_
ParticleInterface * | particles_
std::string | source_

## Constructor & Destructor Documentation

orxonox::ParticleEmitter::ParticleEmitter | ( | BaseObject * | creator | ) |

References orxonox::BaseObject::getScene(), LOD_, orxonox::LODParticle::Normal, particles_, RegisterObject, registerVariables(), orxonox::GameMode::showsGraphics(), and ThrowException.

orxonox::ParticleEmitter::~ParticleEmitter | ( |  | ) |

References orxonox::WorldEntity::detachOgreObject(), orxonox::ParticleInterface::getParticleSystem(), orxonox::BaseObject::isInitialized(), and particles_.

## Member Function Documentation

void orxonox::ParticleEmitter::changedActivity | ( |  | ) | `[virtual]`

This function gets called if the activity of the object changes.

Reimplemented from orxonox::BaseObject.

References orxonox::BaseObject::isActive(), particles_, orxonox::ParticleInterface::setEnabled(), and SUPER.

void orxonox::ParticleEmitter::changedVisibility | ( |  | ) | `[virtual]`

This function gets called if the visibility of the object changes.

Reimplemented from orxonox::BaseObject.

References orxonox::BaseObject::isVisible(), particles_, orxonox::ParticleInterface::setVisible(), and SUPER.

LODParticle::Value orxonox::ParticleEmitter::getLOD | ( |  | ) | const`[inline]`

unsigned int orxonox::ParticleEmitter::getLODxml | ( |  | ) | const`[inline, protected]`

Referenced by XMLPort().

ParticleInterface* orxonox::ParticleEmitter::getParticleInterface | ( |  | ) | const`[inline]`

const std::string& orxonox::ParticleEmitter::getSource | ( |  | ) | const`[inline]`

Referenced by XMLPort().

void orxonox::ParticleEmitter::LODchanged | ( |  | ) | `[protected]`

References LOD_, particles_, and orxonox::ParticleInterface::setDetailLevel().

Referenced by registerVariables().

void orxonox::ParticleEmitter::registerVariables | ( |  | ) |

Reimplemented from orxonox::StaticEntity.

References LOD_, LODchanged(), orxonox::Synchronisable::registerVariable(), source_, sourceChanged(), and orxonox::VariableDirection::ToClient.

Referenced by ParticleEmitter().

void orxonox::ParticleEmitter::setLOD | ( | LODParticle::Value | level | ) | `[inline]`

void orxonox::ParticleEmitter::setLODxml | ( | unsigned int | level | ) | `[inline, protected]`

Referenced by XMLPort().

void orxonox::ParticleEmitter::setSource | ( | const std::string & | source | ) | `[inline]`

Referenced by orxonox::Projectile::collidesAgainst(), orxonox::Pawn::deatheffect(), orxonox::BigExplosion::init(), orxonox::Pawn::spawneffect(), and XMLPort().

void orxonox::ParticleEmitter::sourceChanged | ( |  | ) | `[protected]`

References orxonox::WorldEntity::attachOgreObject(), COUT, orxonox::ParticleInterface::getParticleSystem(), orxonox::BaseObject::getScene(), orxonox::BaseObject::isActive(), orxonox::BaseObject::isVisible(), LOD_, particles_, orxonox::ParticleInterface::setEnabled(), orxonox::ParticleInterface::setVisible(), orxonox::GameMode::showsGraphics(), and source_.

Referenced by registerVariables().

void orxonox::ParticleEmitter::XMLPort | ( | Element & | xmlelement,
|  | XMLPort::Mode | mode |
| ) |  |  | `[virtual]`

XML loading and saving.

Parameters:

  | xmlelement | The XML-element
  | loading | Loading (true) or saving (false)

Returns:
  The XML-element

Reimplemented from orxonox::WorldEntity.

Reimplemented in orxonox::ParticleSpawner.

References getLODxml(), getSource(), orxonox::LODParticle::Normal, setLODxml(), setSource(), SUPER, and XMLPortParam.

## Member Data Documentation

LODParticle::Value orxonox::ParticleEmitter::LOD_`[protected]`

Referenced by LODchanged(), ParticleEmitter(), registerVariables(), and sourceChanged().

ParticleInterface* orxonox::ParticleEmitter::particles_`[protected]`

Referenced by changedActivity(), changedVisibility(), LODchanged(), ParticleEmitter(), sourceChanged(), orxonox::ParticleSpawner::startParticleSpawner(), and ~ParticleEmitter().

std::string orxonox::ParticleEmitter::source_`[protected]`

Referenced by registerVariables(), and sourceChanged().

The documentation for this class was generated from the following files:

- src/orxonox/objects/worldentities/ParticleEmitter.h
- src/orxonox/objects/worldentities/ParticleEmitter.cc